diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-options.cc ns-3.40/src/dsr/model/dsr-options.cc
--- ns-3.39/src/dsr/model/dsr-options.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-options.cc	2023-09-27 13:30:37.638839000 -0700
@@ -125,9 +125,9 @@
                                 std::vector<Ipv4Address>& nodeList)
 {
     NS_LOG_FUNCTION(this << ipv4Address << destAddress);
-    std::vector<Ipv4Address>::iterator it = find(nodeList.begin(), nodeList.end(), destAddress);
+    auto it = find(nodeList.begin(), nodeList.end(), destAddress);
 
-    for (std::vector<Ipv4Address>::iterator i = it; i != nodeList.end(); ++i)
+    for (auto i = it; i != nodeList.end(); ++i)
     {
         if ((ipv4Address == (*i)) && ((*i) != nodeList.back()))
         {
@@ -141,9 +141,9 @@
 DsrOptions::CutRoute(Ipv4Address ipv4Address, std::vector<Ipv4Address>& nodeList)
 {
     NS_LOG_FUNCTION(this << ipv4Address);
-    std::vector<Ipv4Address>::iterator it = find(nodeList.begin(), nodeList.end(), ipv4Address);
+    auto it = find(nodeList.begin(), nodeList.end(), ipv4Address);
     std::vector<Ipv4Address> cutRoute;
-    for (std::vector<Ipv4Address>::iterator i = it; i != nodeList.end(); ++i)
+    for (auto i = it; i != nodeList.end(); ++i)
     {
         cutRoute.push_back(*i);
     }
@@ -190,7 +190,7 @@
                                                                  << vec.back());
         return ipv4Address;
     }
-    for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+    for (auto i = vec.begin(); i != vec.end(); ++i)
     {
         if (ipv4Address == (*i))
         {
@@ -216,7 +216,7 @@
         return nextHop;
     }
 
-    for (std::vector<Ipv4Address>::reverse_iterator ri = vec.rbegin(); ri != vec.rend(); ++ri)
+    for (auto ri = vec.rbegin(); ri != vec.rend(); ++ri)
     {
         if (ipv4Address == (*ri))
         {
@@ -237,7 +237,7 @@
     Ipv4Address nextTwoHop;
     NS_LOG_DEBUG("The vector size " << vec.size());
     NS_ASSERT(vec.size() > 2);
-    for (std::vector<Ipv4Address>::reverse_iterator ri = vec.rbegin(); ri != vec.rend(); ++ri)
+    for (auto ri = vec.rbegin(); ri != vec.rend(); ++ri)
     {
         if (ipv4Address == (*ri))
         {
@@ -264,7 +264,7 @@
     else
     {
         NS_LOG_DEBUG("Print all the elements in a vector");
-        for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+        for (auto i = vec.begin(); i != vec.end(); ++i)
         {
             NS_LOG_DEBUG("The ip address " << *i);
         }
@@ -275,9 +275,9 @@
 DsrOptions::IfDuplicates(std::vector<Ipv4Address>& vec, std::vector<Ipv4Address>& vec2)
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+    for (auto i = vec.begin(); i != vec.end(); ++i)
     {
-        for (std::vector<Ipv4Address>::const_iterator j = vec2.begin(); j != vec2.end(); ++j)
+        for (auto j = vec2.begin(); j != vec2.end(); ++j)
         {
             if ((*i) == (*j))
             {
@@ -292,7 +292,7 @@
 DsrOptions::CheckDuplicates(Ipv4Address ipv4Address, std::vector<Ipv4Address>& vec)
 {
     NS_LOG_FUNCTION(this << ipv4Address);
-    for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+    for (auto i = vec.begin(); i != vec.end(); ++i)
     {
         if ((*i) == ipv4Address)
         {
@@ -311,7 +311,7 @@
     std::vector<Ipv4Address> vec2(vec); // declare vec2 as a copy of the vec
     PrintVector(vec2);                  // Print all the ip address in the route
     vec.clear();                        // clear vec
-    for (std::vector<Ipv4Address>::const_iterator i = vec2.begin(); i != vec2.end(); ++i)
+    for (auto i = vec2.begin(); i != vec2.end(); ++i)
     {
         if (vec.empty())
         {
@@ -319,7 +319,7 @@
             continue;
         }
 
-        for (std::vector<Ipv4Address>::iterator j = vec.begin(); j != vec.end(); ++j)
+        for (auto j = vec.begin(); j != vec.end(); ++j)
         {
             if ((*i) == (*j))
             {
@@ -679,9 +679,7 @@
                 std::vector<Ipv4Address> changeRoute(nodeList);
                 changeRoute.push_back(ipv4Address); // push back our own address
                 m_finalRoute.clear();               // get a clear route vector
-                for (std::vector<Ipv4Address>::iterator i = changeRoute.begin();
-                     i != changeRoute.end();
-                     ++i)
+                for (auto i = changeRoute.begin(); i != changeRoute.end(); ++i)
                 {
                     m_finalRoute.push_back(*i); // Get the full route from source to destination
                 }
@@ -805,8 +803,7 @@
             /**
              * push back the intermediate node address from the source to this node
              */
-            for (std::vector<Ipv4Address>::iterator i = saveRoute.begin(); i != saveRoute.end();
-                 ++i)
+            for (auto i = saveRoute.begin(); i != saveRoute.end(); ++i)
             {
                 m_finalRoute.push_back(*i);
             }
@@ -814,7 +811,7 @@
              * push back the route vector we found in our route cache to destination, including this
              * node's address
              */
-            for (std::vector<Ipv4Address>::iterator j = ip.begin(); j != ip.end(); ++j)
+            for (auto j = ip.begin(); j != ip.end(); ++j)
             {
                 m_finalRoute.push_back(*j);
             }
@@ -1389,7 +1386,7 @@
 
         // Get the option type value
         uint32_t size = p->GetSize();
-        uint8_t* data = new uint8_t[size];
+        auto data = new uint8_t[size];
         p->CopyData(data, size);
         uint8_t optionType = 0;
         optionType = *(data);
@@ -1560,7 +1557,7 @@
                          << (uint32_t)protocol << isPromisc);
     Ptr<Packet> p = packet->Copy();
     uint32_t size = p->GetSize();
-    uint8_t* data = new uint8_t[size];
+    auto data = new uint8_t[size];
     p->CopyData(data, size);
     uint8_t errorType = *(data + 2);
     /*
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-passive-buff.cc ns-3.40/src/dsr/model/dsr-passive-buff.cc
--- ns-3.39/src/dsr/model/dsr-passive-buff.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-passive-buff.cc	2023-09-27 13:30:37.638839000 -0700
@@ -76,9 +76,7 @@
 DsrPassiveBuffer::Enqueue(DsrPassiveBuffEntry& entry)
 {
     Purge();
-    for (std::vector<DsrPassiveBuffEntry>::const_iterator i = m_passiveBuffer.begin();
-         i != m_passiveBuffer.end();
-         ++i)
+    for (auto i = m_passiveBuffer.begin(); i != m_passiveBuffer.end(); ++i)
     {
         //      NS_LOG_INFO ("packet id " << i->GetPacket ()->GetUid () << " " << entry.GetPacket
         //      ()->GetUid () << " source " << i->GetSource () << " " << entry.GetSource ()
@@ -119,9 +117,7 @@
 bool
 DsrPassiveBuffer::AllEqual(DsrPassiveBuffEntry& entry)
 {
-    for (std::vector<DsrPassiveBuffEntry>::iterator i = m_passiveBuffer.begin();
-         i != m_passiveBuffer.end();
-         ++i)
+    for (auto i = m_passiveBuffer.begin(); i != m_passiveBuffer.end(); ++i)
     {
         //      NS_LOG_INFO ("packet id " << i->GetPacket ()->GetUid () << " " << entry.GetPacket
         //      ()->GetUid () << " source " << i->GetSource () << " " << entry.GetSource ()
@@ -156,9 +152,7 @@
     /*
      * Dequeue the entry with destination address dst
      */
-    for (std::vector<DsrPassiveBuffEntry>::iterator i = m_passiveBuffer.begin();
-         i != m_passiveBuffer.end();
-         ++i)
+    for (auto i = m_passiveBuffer.begin(); i != m_passiveBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -177,9 +171,7 @@
     /*
      * Make sure if the send buffer contains entry with certain dst
      */
-    for (std::vector<DsrPassiveBuffEntry>::const_iterator i = m_passiveBuffer.begin();
-         i != m_passiveBuffer.end();
-         ++i)
+    for (auto i = m_passiveBuffer.begin(); i != m_passiveBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -213,9 +205,7 @@
      */
     NS_LOG_DEBUG("The passive buffer size " << m_passiveBuffer.size());
     IsExpired pred;
-    for (std::vector<DsrPassiveBuffEntry>::iterator i = m_passiveBuffer.begin();
-         i != m_passiveBuffer.end();
-         ++i)
+    for (auto i = m_passiveBuffer.begin(); i != m_passiveBuffer.end(); ++i)
     {
         if (pred(*i))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-rcache.cc ns-3.40/src/dsr/model/dsr-rcache.cc
--- ns-3.39/src/dsr/model/dsr-rcache.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-rcache.cc	2023-09-27 13:30:37.638839000 -0700
@@ -185,8 +185,7 @@
 DsrRouteCache::UpdateRouteEntry(Ipv4Address dst)
 {
     NS_LOG_FUNCTION(this << dst);
-    std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator i =
-        m_sortedRoutes.find(dst);
+    auto i = m_sortedRoutes.find(dst);
     if (i == m_sortedRoutes.end())
     {
         NS_LOG_LOGIC("Failed to find the route entry for the destination " << dst);
@@ -204,8 +203,7 @@
         /*
          * Save the new route cache along with the destination address in map
          */
-        std::pair<std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator, bool> result =
-            m_sortedRoutes.insert(std::make_pair(dst, rtVector));
+        auto result = m_sortedRoutes.insert(std::make_pair(dst, rtVector));
         return result.second;
     }
     return false;
@@ -226,32 +224,24 @@
         NS_LOG_LOGIC("Route to " << id << " not found; m_sortedRoutes is empty");
         return false;
     }
-    std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator i =
-        m_sortedRoutes.find(id);
+    auto i = m_sortedRoutes.find(id);
     if (i == m_sortedRoutes.end())
     {
         NS_LOG_LOGIC("No Direct Route to " << id << " found");
-        for (std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator j =
-                 m_sortedRoutes.begin();
-             j != m_sortedRoutes.end();
-             ++j)
+        for (auto j = m_sortedRoutes.begin(); j != m_sortedRoutes.end(); ++j)
         {
             std::list<DsrRouteCacheEntry> rtVector =
                 j->second; // The route cache vector linked with destination address
             /*
              * Loop through the possibly multiple routes within the route vector
              */
-            for (std::list<DsrRouteCacheEntry>::const_iterator k = rtVector.begin();
-                 k != rtVector.end();
-                 ++k)
+            for (auto k = rtVector.begin(); k != rtVector.end(); ++k)
             {
                 // return the first route in the route vector
                 DsrRouteCacheEntry::IP_VECTOR routeVector = k->GetVector();
                 DsrRouteCacheEntry::IP_VECTOR changeVector;
 
-                for (DsrRouteCacheEntry::IP_VECTOR::iterator l = routeVector.begin();
-                     l != routeVector.end();
-                     ++l)
+                for (auto l = routeVector.begin(); l != routeVector.end(); ++l)
                 {
                     changeVector.push_back(*l);
 
@@ -283,8 +273,7 @@
         }
     }
     NS_LOG_INFO("Here we check the route cache again after updated the sub routes");
-    std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator m =
-        m_sortedRoutes.find(id);
+    auto m = m_sortedRoutes.find(id);
     if (m == m_sortedRoutes.end())
     {
         NS_LOG_LOGIC("No updated route till last time");
@@ -336,9 +325,7 @@
     std::map<Ipv4Address, uint32_t> d;
     // @pre preceding node
     std::map<Ipv4Address, Ipv4Address> pre;
-    for (std::map<Ipv4Address, std::map<Ipv4Address, uint32_t>>::iterator i = m_netGraph.begin();
-         i != m_netGraph.end();
-         ++i)
+    for (auto i = m_netGraph.begin(); i != m_netGraph.end(); ++i)
     {
         if (i->second.find(source) != i->second.end())
         {
@@ -358,11 +345,11 @@
     // the node set which shortest distance has been calculated, if true calculated
     std::map<Ipv4Address, bool> s;
     double temp = MAXWEIGHT;
-    Ipv4Address tempip = Ipv4Address("255.255.255.255");
+    Ipv4Address tempip("255.255.255.255");
     for (uint32_t i = 0; i < m_netGraph.size(); i++)
     {
         temp = MAXWEIGHT;
-        for (std::map<Ipv4Address, uint32_t>::const_iterator j = d.begin(); j != d.end(); ++j)
+        for (auto j = d.begin(); j != d.end(); ++j)
         {
             Ipv4Address ip = j->first;
             if (s.find(ip) == s.end())
@@ -380,9 +367,7 @@
         if (!tempip.IsBroadcast())
         {
             s[tempip] = true;
-            for (std::map<Ipv4Address, uint32_t>::const_iterator k = m_netGraph[tempip].begin();
-                 k != m_netGraph[tempip].end();
-                 ++k)
+            for (auto k = m_netGraph[tempip].begin(); k != m_netGraph[tempip].end(); ++k)
             {
                 if (s.find(k->first) == s.end() && d[k->first] > d[tempip] + k->second)
                 {
@@ -398,10 +383,8 @@
                  */
                 else if (d[k->first] == d[tempip] + k->second)
                 {
-                    std::map<Link, DsrLinkStab>::iterator oldlink =
-                        m_linkCache.find(Link(k->first, pre[k->first]));
-                    std::map<Link, DsrLinkStab>::iterator newlink =
-                        m_linkCache.find(Link(k->first, tempip));
+                    auto oldlink = m_linkCache.find(Link(k->first, pre[k->first]));
+                    auto newlink = m_linkCache.find(Link(k->first, tempip));
                     if (oldlink != m_linkCache.end() && newlink != m_linkCache.end())
                     {
                         if (oldlink->second.GetLinkStability() < newlink->second.GetLinkStability())
@@ -421,7 +404,7 @@
     }
     // clean the best route table
     m_bestRoutesTable_link.clear();
-    for (std::map<Ipv4Address, Ipv4Address>::iterator i = pre.begin(); i != pre.end(); ++i)
+    for (auto i = pre.begin(); i != pre.end(); ++i)
     {
         // loop for all vertices
         DsrRouteCacheEntry::IP_VECTOR route;
@@ -450,8 +433,7 @@
     NS_LOG_FUNCTION(this << id);
     /// We need to purge the link node cache
     PurgeLinkNode();
-    std::map<Ipv4Address, DsrRouteCacheEntry::IP_VECTOR>::const_iterator i =
-        m_bestRoutesTable_link.find(id);
+    auto i = m_bestRoutesTable_link.find(id);
     if (i == m_bestRoutesTable_link.end())
     {
         NS_LOG_INFO("No route find to " << id);
@@ -479,10 +461,10 @@
 DsrRouteCache::PurgeLinkNode()
 {
     NS_LOG_FUNCTION(this);
-    for (std::map<Link, DsrLinkStab>::iterator i = m_linkCache.begin(); i != m_linkCache.end();)
+    for (auto i = m_linkCache.begin(); i != m_linkCache.end();)
     {
         NS_LOG_DEBUG("The link stability " << i->second.GetLinkStability().As(Time::S));
-        std::map<Link, DsrLinkStab>::iterator itmp = i;
+        auto itmp = i;
         if (i->second.GetLinkStability() <= Seconds(0))
         {
             ++i;
@@ -494,11 +476,10 @@
         }
     }
     /// may need to remove them after verify
-    for (std::map<Ipv4Address, DsrNodeStab>::iterator i = m_nodeCache.begin();
-         i != m_nodeCache.end();)
+    for (auto i = m_nodeCache.begin(); i != m_nodeCache.end();)
     {
         NS_LOG_DEBUG("The node stability " << i->second.GetNodeStability().As(Time::S));
-        std::map<Ipv4Address, DsrNodeStab>::iterator itmp = i;
+        auto itmp = i;
         if (i->second.GetNodeStability() <= Seconds(0))
         {
             ++i;
@@ -516,7 +497,7 @@
 {
     NS_LOG_FUNCTION(this);
     m_netGraph.clear();
-    for (std::map<Link, DsrLinkStab>::iterator i = m_linkCache.begin(); i != m_linkCache.end(); ++i)
+    for (auto i = m_linkCache.begin(); i != m_linkCache.end(); ++i)
     {
         // Here the weight is set as 1
         /// \todo May need to set different weight for different link here later
@@ -530,7 +511,7 @@
 DsrRouteCache::IncStability(Ipv4Address node)
 {
     NS_LOG_FUNCTION(this << node);
-    std::map<Ipv4Address, DsrNodeStab>::const_iterator i = m_nodeCache.find(node);
+    auto i = m_nodeCache.find(node);
     if (i == m_nodeCache.end())
     {
         NS_LOG_INFO("The initial stability " << m_initStability.As(Time::S));
@@ -555,7 +536,7 @@
 DsrRouteCache::DecStability(Ipv4Address node)
 {
     NS_LOG_FUNCTION(this << node);
-    std::map<Ipv4Address, DsrNodeStab>::const_iterator i = m_nodeCache.find(node);
+    auto i = m_nodeCache.find(node);
     if (i == m_nodeCache.end())
     {
         DsrNodeStab ns(m_initStability);
@@ -636,7 +617,7 @@
         NS_LOG_INFO("The route is too short");
         return;
     }
-    for (DsrRouteCacheEntry::IP_VECTOR::iterator i = rt.begin(); i != rt.end() - 1; ++i)
+    for (auto i = rt.begin(); i != rt.end() - 1; ++i)
     {
         Link link(*i, *(i + 1));
         if (m_linkCache.find(link) != m_linkCache.end())
@@ -655,7 +636,7 @@
         }
     }
     /// Increase the stability of the node cache
-    for (DsrRouteCacheEntry::IP_VECTOR::iterator i = rt.begin(); i != rt.end(); ++i)
+    for (auto i = rt.begin(); i != rt.end(); ++i)
     {
         if (m_nodeCache.find(*i) != m_nodeCache.end())
         {
@@ -682,8 +663,7 @@
     std::vector<Ipv4Address> route = rt.GetVector();
 
     NS_LOG_DEBUG("The route destination we have " << dst);
-    std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::const_iterator i =
-        m_sortedRoutes.find(dst);
+    auto i = m_sortedRoutes.find(dst);
 
     if (i == m_sortedRoutes.end())
     {
@@ -692,8 +672,7 @@
         /**
          * Save the new route cache along with the destination address in map
          */
-        std::pair<std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator, bool> result =
-            m_sortedRoutes.insert(std::make_pair(dst, rtVector));
+        auto result = m_sortedRoutes.insert(std::make_pair(dst, rtVector));
         return result.second;
     }
 
@@ -734,8 +713,7 @@
             /**
              * Save the new route cache along with the destination address in map
              */
-            std::pair<std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator, bool> result =
-                m_sortedRoutes.insert(std::make_pair(dst, rtVector));
+            auto result = m_sortedRoutes.insert(std::make_pair(dst, rtVector));
             return result.second;
         }
         else
@@ -751,7 +729,7 @@
 DsrRouteCache::FindSameRoute(DsrRouteCacheEntry& rt, std::list<DsrRouteCacheEntry>& rtVector)
 {
     NS_LOG_FUNCTION(this);
-    for (std::list<DsrRouteCacheEntry>::iterator i = rtVector.begin(); i != rtVector.end(); ++i)
+    for (auto i = rtVector.begin(); i != rtVector.end(); ++i)
     {
         // return the first route in the route vector
         DsrRouteCacheEntry::IP_VECTOR routeVector = i->GetVector();
@@ -773,8 +751,7 @@
             /*
              * Save the new route cache along with the destination address in map
              */
-            std::pair<std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator, bool> result =
-                m_sortedRoutes.insert(std::make_pair(rt.GetDestination(), rtVector));
+            auto result = m_sortedRoutes.insert(std::make_pair(rt.GetDestination(), rtVector));
             return result.second;
         }
     }
@@ -819,7 +796,7 @@
         m_linkCache.erase(link2);
         NS_LOG_DEBUG("The link cache size " << m_linkCache.size());
 
-        std::map<Ipv4Address, DsrNodeStab>::iterator i = m_nodeCache.find(errorSrc);
+        auto i = m_nodeCache.find(errorSrc);
         if (i == m_nodeCache.end())
         {
             NS_LOG_LOGIC("Update the node stability unsuccessfuly");
@@ -854,17 +831,15 @@
         /*
          * Loop all the routes saved in the route cache
          */
-        for (std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator j =
-                 m_sortedRoutes.begin();
-             j != m_sortedRoutes.end();)
+        for (auto j = m_sortedRoutes.begin(); j != m_sortedRoutes.end();)
         {
-            std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator jtmp = j;
+            auto jtmp = j;
             Ipv4Address address = j->first;
             std::list<DsrRouteCacheEntry> rtVector = j->second;
             /*
              * Loop all the routes for a single destination
              */
-            for (std::list<DsrRouteCacheEntry>::iterator k = rtVector.begin(); k != rtVector.end();)
+            for (auto k = rtVector.begin(); k != rtVector.end();)
             {
                 // return the first route in the route vector
                 DsrRouteCacheEntry::IP_VECTOR routeVector = k->GetVector();
@@ -872,9 +847,7 @@
                 /*
                  * Loop the ip addresses within a single route entry
                  */
-                for (DsrRouteCacheEntry::IP_VECTOR::iterator i = routeVector.begin();
-                     i != routeVector.end();
-                     ++i)
+                for (auto i = routeVector.begin(); i != routeVector.end(); ++i)
                 {
                     if (*i != errorSrc)
                     {
@@ -972,7 +945,7 @@
     else
     {
         NS_LOG_DEBUG("Print all the elements in a vector");
-        for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+        for (auto i = vec.begin(); i != vec.end(); ++i)
         {
             NS_LOG_DEBUG("The ip address " << *i);
         }
@@ -983,7 +956,7 @@
 DsrRouteCache::PrintRouteVector(std::list<DsrRouteCacheEntry> route)
 {
     NS_LOG_FUNCTION(this);
-    for (std::list<DsrRouteCacheEntry>::iterator i = route.begin(); i != route.end(); i++)
+    for (auto i = route.begin(); i != route.end(); i++)
     {
         std::vector<Ipv4Address> path = i->GetVector();
         NS_LOG_INFO("Route NO. ");
@@ -1001,11 +974,10 @@
         NS_LOG_DEBUG("The route cache is empty");
         return;
     }
-    for (std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator i = m_sortedRoutes.begin();
-         i != m_sortedRoutes.end();)
+    for (auto i = m_sortedRoutes.begin(); i != m_sortedRoutes.end();)
     {
         // Loop of route cache entry with the route size
-        std::map<Ipv4Address, std::list<DsrRouteCacheEntry>>::iterator itmp = i;
+        auto itmp = i;
         /*
          * The route cache entry vector
          */
@@ -1014,7 +986,7 @@
         NS_LOG_DEBUG("The route vector size of 1 " << dst << " " << rtVector.size());
         if (!rtVector.empty())
         {
-            for (std::list<DsrRouteCacheEntry>::iterator j = rtVector.begin(); j != rtVector.end();)
+            for (auto j = rtVector.begin(); j != rtVector.end();)
             {
                 NS_LOG_DEBUG("The expire time of every entry with expire time "
                              << j->GetExpireTime());
@@ -1066,9 +1038,7 @@
     Purge();
     os << "\nDSR Route Cache\n"
        << "Destination\tGateway\t\tInterface\tFlag\tExpire\tHops\n";
-    for (std::list<DsrRouteCacheEntry>::const_iterator i = m_routeEntryVector.begin();
-         i != m_routeEntryVector.end();
-         ++i)
+    for (auto i = m_routeEntryVector.begin(); i != m_routeEntryVector.end(); ++i)
     {
         i->Print(os);
     }
@@ -1083,7 +1053,7 @@
 DsrRouteCache::CheckUniqueAckId(Ipv4Address nextHop)
 {
     NS_LOG_FUNCTION(this);
-    std::map<Ipv4Address, uint16_t>::const_iterator i = m_ackIdCache.find(nextHop);
+    auto i = m_ackIdCache.find(nextHop);
     if (i == m_ackIdCache.end())
     {
         NS_LOG_LOGIC("No Ack id for " << nextHop
@@ -1114,7 +1084,7 @@
 {
     NS_LOG_FUNCTION(this);
     PurgeMac(); // purge the mac cache
-    for (std::vector<Neighbor>::const_iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_neighborAddress == addr)
         {
@@ -1129,7 +1099,7 @@
 {
     NS_LOG_FUNCTION(this);
     PurgeMac();
-    for (std::vector<Neighbor>::const_iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_neighborAddress == addr)
         {
@@ -1143,9 +1113,9 @@
 DsrRouteCache::UpdateNeighbor(std::vector<Ipv4Address> nodeList, Time expire)
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Neighbor>::iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
-        for (std::vector<Ipv4Address>::iterator j = nodeList.begin(); j != nodeList.end(); ++j)
+        for (auto j = nodeList.begin(); j != nodeList.end(); ++j)
         {
             if (i->m_neighborAddress == (*j))
             {
@@ -1170,7 +1140,7 @@
 DsrRouteCache::AddNeighbor(std::vector<Ipv4Address> nodeList, Ipv4Address ownAddress, Time expire)
 {
     NS_LOG_LOGIC("Add neighbor number " << nodeList.size());
-    for (std::vector<Ipv4Address>::iterator j = nodeList.begin(); j != nodeList.end();)
+    for (auto j = nodeList.begin(); j != nodeList.end();)
     {
         Ipv4Address addr = *j;
         if (addr == ownAddress)
@@ -1214,7 +1184,7 @@
     CloseNeighbor pred;
     if (!m_handleLinkFailure.IsNull())
     {
-        for (std::vector<Neighbor>::iterator j = m_nb.begin(); j != m_nb.end(); ++j)
+        for (auto j = m_nb.begin(); j != m_nb.end(); ++j)
         {
             if (pred(*j))
             {
@@ -1252,7 +1222,7 @@
 DsrRouteCache::LookupMacAddress(Ipv4Address addr)
 {
     Mac48Address hwaddr;
-    for (std::vector<Ptr<ArpCache>>::const_iterator i = m_arp.begin(); i != m_arp.end(); ++i)
+    for (auto i = m_arp.begin(); i != m_arp.end(); ++i)
     {
         ArpCache::Entry* entry = (*i)->Lookup(addr);
         if (entry != nullptr && (entry->IsAlive() || entry->IsPermanent()) && !entry->IsExpired())
@@ -1269,7 +1239,7 @@
 {
     Mac48Address addr = hdr.GetAddr1();
 
-    for (std::vector<Neighbor>::iterator i = m_nb.begin(); i != m_nb.end(); ++i)
+    for (auto i = m_nb.begin(); i != m_nb.end(); ++i)
     {
         if (i->m_hardwareAddress == addr)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-rcache.h ns-3.40/src/dsr/model/dsr-rcache.h
--- ns-3.39/src/dsr/model/dsr-rcache.h	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-rcache.h	2023-09-27 13:30:37.638839000 -0700
@@ -356,8 +356,8 @@
             NS_ASSERT(false);
             return false;
         }
-        IP_VECTOR::const_iterator j = o.m_path.begin();
-        for (IP_VECTOR::const_iterator i = m_path.begin(); i != m_path.end(); i++, j++)
+        auto j = o.m_path.begin();
+        for (auto i = m_path.begin(); i != m_path.end(); i++, j++)
         {
             /*
              * Verify if neither the entry are not 0 and they equal to each other
